﻿Public Class main 
    Dim ds As DataSet

    Public book_code As String
    Public id_code As String

    Public Sub sql_execute(ByVal SQL As String, ByVal Dataset As DataSet)
        DCom.CommandText = SQL
        DA = New OleDb.OleDbDataAdapter(SQL, Con)
        DA.Fill(Dataset, "book")
        Dim i As Integer
        i = 0
        Do While i < Dataset.Tables("book").Rows.Count
            If Dataset.Tables("book").Rows(i).Item(6).ToString Like "0" Then
                Dataset.Tables("book").Rows(i).Item(6) = "가능"
            Else
                Dataset.Tables("book").Rows(i).Item(6) = "불가능"
            End If
            i = i + 1
        Loop
        BindingSource1.DataSource = Dataset.Tables("book")
        DataGridView1.DataSource = BindingSource1
        book_counter()
        book_header()
        DataGridView1.Refresh()
    End Sub

    Public Sub book_counter()
        Dim i As Integer
        i = DataGridView1.RowCount
        Label3.Text = "총 " & i & "권"
    End Sub

    Public Sub book_header()
        DataGridView1.Columns(0).HeaderText = "코드"
        DataGridView1.Columns(1).HeaderText = "제목"
        DataGridView1.Columns(2).HeaderText = "저자"
        DataGridView1.Columns(3).HeaderText = "출판사"
        DataGridView1.Columns(4).Visible = False
        DataGridView1.Columns(5).Visible = False
        DataGridView1.Columns(6).HeaderText = "대여"
        DataGridView1.Columns(7).Visible = False
        DataGridView1.Columns(8).Visible = False

        DataGridView1.Columns(0).Width = 80
        DataGridView1.Columns(1).Width = 150
        DataGridView1.Columns(2).Width = 90
        DataGridView1.Columns(3).Width = 110
        DataGridView1.Columns(6).Width = 80
    End Sub

    Public Sub list_search(ByVal Find As String, ByVal Sort As String)
        ds = New DataSet
        If Find = "" And Sort = "" Then
            SQL = "Select * From book ORDER BY b_title ASC"
            sql_execute(SQL, ds)
        ElseIf Find = "" And Sort <> "" Then
            If Sort = "title" Then
                SQL = "Select * From book ORDER BY b_title ASC"
            ElseIf Sort = "name" Then
                SQL = "Select * From book ORDER BY b_name ASC"
            ElseIf Sort = "publishing" Then
                SQL = "Select * From book ORDER BY b_publishing ASC"
            ElseIf Sort = "lent" Then
                SQL = "Select * From book ORDER BY b_lent ASC"
            End If
            sql_execute(SQL, ds)
        ElseIf Find <> "" Then
            If RadioButton1.Checked Then
                SQL = "Select * From book Where b_title Like '%" & Find & "%'"
            ElseIf RadioButton2.Checked Then
                SQL = "Select * From book Where b_code = '" & Find & "'"
            End If
            sql_execute(SQL, ds)
            If ds.Tables("book").Rows.Count = 0 Then
                MsgBox("해당 도서가 없습니다", , "확인")
                SQL = "Select * From book ORDER BY b_title ASC"
                sql_execute(SQL, ds)
            End If
        End If
    End Sub

    Private Sub DataGridView1_CellMouseDoubleClick(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellMouseEventArgs) Handles DataGridView1.CellMouseDoubleClick
        inforbook.Label2.Text = DataGridView1.Item(0, Int(DataGridView1.CurrentRow.Index.ToString)).Value.ToString
        inforbook.Show()
    End Sub

    Public Sub sql_execute2(ByVal SQL As String, ByVal Dataset As DataSet)
        DCom.CommandText = SQL
        DA = New OleDb.OleDbDataAdapter(SQL, Con)
        DA.Fill(Dataset, "member")
        BindingSource2.DataSource = Dataset.Tables("member")
        DataGridView2.DataSource = BindingSource2
        lentm_counter()
        lentm_header()
        DataGridView2.Refresh()
    End Sub

    Public Sub lentm_counter()
        Dim i As Integer
        i = DataGridView2.RowCount
        Label2.Text = "총 " & i & "명"
    End Sub

    Public Sub lentm_header()
        DataGridView2.Columns(0).HeaderText = "ID"
        DataGridView2.Columns(1).HeaderText = "이름"
        DataGridView2.Columns(2).Visible = False
        DataGridView2.Columns(3).Visible = False
        DataGridView2.Columns(4).Visible = False
        DataGridView2.Columns(5).Visible = False
        DataGridView2.Columns(6).HeaderText = "권수"
        DataGridView2.Columns(7).Visible = False

        DataGridView2.Columns(0).Width = 80
        DataGridView2.Columns(1).Width = 80
        DataGridView2.Columns(6).Width = 80
    End Sub

    Public Sub lent_id()
        ds = New DataSet
        SQL = "Select * From member Where m_lent <> 0 ORDER BY m_id ASC"
        sql_execute2(SQL, ds)
    End Sub

    Private Sub DataGridView2_CellMouseDoubleClick(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellMouseEventArgs) Handles DataGridView2.CellMouseDoubleClick
        inforLentUser.Label1.Text = DataGridView2.Item(0, Int(DataGridView2.CurrentRow.Index.ToString)).Value.ToString
        inforLentUser.Show()
    End Sub

    Public Sub sql_execute3(ByVal SQL As String, ByVal Dataset As DataSet)
        DCom.CommandText = SQL
        DA = New OleDb.OleDbDataAdapter(SQL, Con)
        DA.Fill(Dataset, "book")
        Dim i As Integer
        i = 0
        Dataset.Tables("book").Columns.Add("연체일")
        Do While i < Dataset.Tables("book").Rows.Count
            Dataset.Tables("book").Rows(i).Item(3) = Strings.Left(Dataset.Tables("book").Rows(i).Item(3), 10)
            Dim lentDiff As String
            Dim ti As Date
            ti = Dataset.Tables("book").Rows(0).Item(3)
            lentDiff = DateDiff("d", ti, Now()) - 10
            Dataset.Tables("book").Rows(i).Item(4) = lentDiff.ToString & "일"
            i = i + 1
        Loop
        BindingSource3.DataSource = Dataset.Tables("book")
        DataGridView3.DataSource = BindingSource3
        blackm_counter()
        blackm_header()
        DataGridView3.Refresh()
    End Sub

    Public Sub blackm_counter()
        Dim i As Integer
        i = DataGridView3.RowCount
        Label4.Text = "총 " & i & "명"
    End Sub

    Public Sub blackm_header()
        DataGridView3.Columns(0).HeaderText = "이름"
        DataGridView3.Columns(1).HeaderText = "코드"
        DataGridView3.Columns(2).HeaderText = "제목"
        DataGridView3.Columns(3).HeaderText = "대출일"

        DataGridView3.Columns(0).Width = 80
        DataGridView3.Columns(1).Width = 60
        DataGridView3.Columns(2).Width = 100
        DataGridView3.Columns(3).Width = 80
        DataGridView3.Columns(4).Width = 70
    End Sub

    Public Sub blacklist()
        ds = New DataSet
        SQL = "Select B.m_name, A.b_code, A.b_title, A.b_lent_date From book A Inner Join member B on A.b_lent = B.m_id Where A.b_lent_date + 10 < now() ORDER BY A.b_lent_date ASC"
        sql_execute3(SQL, ds)
    End Sub

    Private Sub main_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Call list_search("", "")
        Call lent_id()
        Call blacklist()
        Left = 0
        Top = 0
    End Sub

    Private Sub btnFind_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFind.Click
        If Trim(txtFind1.Text) = "" Then
            MsgBox("검색 미입력", , "확인")
        Else
            Call list_search(Trim(txtFind1.Text), "")
        End If
    End Sub

    Private Sub btnLentOrReturn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLentOrReturn.Click
        ds = New DataSet
        If Trim(txtFind2.Text) = "" Then
            MsgBox("도서코드 미입력", , "확인")
            txtFind2.Focus()
        Else
            If RadioButton3.Checked Then
                SQL = "Select * From book Where b_code = '" & txtFind2.Text & "'"
                DCom.CommandText = SQL
                DA = New OleDb.OleDbDataAdapter(SQL, Con)
                DA.Fill(ds, "book")

                If ds.Tables("book").Rows.Count = 0 Then
                    MsgBox("해당되는 도서가 없습니다.", , "확인")
                    txtFind2.Text = ""
                    txtFind2.Focus()
                Else
                    If ds.Tables("book").Rows(0).Item(6).ToString Like "0" Then
                        memid.Show()
                    Else
                        MsgBox("이미 대여된 도서입니다.", , "확인")
                        txtFind2.Text = ""
                        txtFind2.Focus()
                    End If
                End If
            ElseIf RadioButton4.Checked Then
                Ret = MsgBox("해당 도서를 반납하시겠습니까?", vbYesNo, "확인")
                If Ret = vbYes Then
                    SQL = "Select * From book Where b_code='" & txtFind2.Text & "'"
                    DCom.CommandText = SQL
                    DA = New OleDb.OleDbDataAdapter(SQL, Con)
                    DA.Fill(ds, "book")
                    If ds.Tables("book").Rows.Count = 0 Then
                        MsgBox("해당되는 도서가 없습니다.", , "확인")
                        txtFind2.Text = ""
                        txtFind2.Focus()
                    ElseIf ds.Tables("book").Rows(0).Item(6).ToString Like "0" Then
                        MsgBox("대여되지 않은 도서입니다.", , "확인")
                        txtFind2.Text = ""
                        txtFind2.Focus()
                    Else
                        id_code = ds.Tables("book").Rows(0).Item(6)
                        SQL = "Update book Set b_lent = '0', b_lent_date = Null Where b_code = '" & txtFind2.Text & "'"
                        DCom.CommandText = SQL
                        DCom.ExecuteNonQuery()
                        DA.Fill(ds, "book")

                        SQL = "Update member Set m_lent = m_lent-1 Where m_id = '" & id_code & "'"
                        DCom.CommandText = SQL
                        DCom.ExecuteNonQuery()
                        DA.Fill(ds, "member")

                        txtFind2.Text = ""
                        txtFind2.Focus()

                        Call list_search("", "")
                        lent_id()
                        blacklist()
                    End If
                End If
            End If
        End If
    End Sub

    Private Sub btnPrev_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrev.Click
        Call list_search("", "")
    End Sub

    Private Sub btnSortByTitle_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSortByTitle.Click
        Call list_search("", "title")
    End Sub

    Private Sub btnSortByAuthor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSotrByAuthor.Click
        Call list_search("", "name")
    End Sub

    Private Sub btnSortByPublisher_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSortByPublisher.Click
        Call list_search("", "publishing")
    End Sub

    Private Sub btnSortByLending_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSortByLending.Click
        Call list_search("", "lent")
    End Sub

    Private Sub RadioButton1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles RadioButton1.Click
        txtFind1.Focus()
    End Sub

    Private Sub RadioButton2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton2.Click
        txtFind1.Focus()
    End Sub

    Private Sub RadioButton3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton3.Click
        txtFind2.Focus()
    End Sub

    Private Sub RadioButton4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton4.Click
        txtFind2.Focus()
    End Sub

    Private Sub txtFind1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles txtFind1.KeyDown
        If e.KeyCode = Keys.Enter Then
            btnFind.PerformClick()
        End If
    End Sub

    Private Sub txtFind2_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles txtFind2.KeyDown
        If e.KeyCode = Keys.Enter Then
            btnLentOrReturn.PerformClick()
        End If
    End Sub
End Class